package pltag.german;

import java.util.ArrayList;

public abstract class AbstractPredictionTreeExtractor {

	protected boolean multiAnchoredTrees;
	
	protected TigerTree currTree = null;
	protected StringBuffer currErrorString = null;
	protected ArrayList<PredictionTree> predLex = new ArrayList<PredictionTree>();
	
	public AbstractPredictionTreeExtractor(boolean mat) {
		multiAnchoredTrees = mat;
	}
	
	public ArrayList<PredictionTree> createPredLexicon(TigerTree tree, StringBuffer sb) {
		currTree = tree;
		currErrorString = sb;
		predLex = new ArrayList<PredictionTree>();
		
		markNodesInTreeAsNotPredicted(currTree.getRoot());
		
		extract();
		return predLex;
	}
	
	abstract protected void extract();
	
	private void markNodesInTreeAsNotPredicted(TreeNode node) {
		node.setPredictedBottom(false);
		node.setPredictedTop(false);
		
		for (TreeNode child : node.getChildren()) {
			markNodesInTreeAsNotPredicted(child);
		}
	}
}
