package pltag.german;

import java.util.HashMap;



public class InnerNode extends TreeNode {

	public InnerNode(int id, String cat, HashMap<String, Trace> traceList) {
		super(id, cat);
		traceList = treatTrace(traceList);
	}
	
	public InnerNode(IDGenerator idgen, String cat) {
		super(idgen, cat);
	}
	
	public InnerNode(IDGenerator idgen, String cat, boolean b) {
		super(idgen, cat, b);
	}

	protected HashMap<String, Trace> treatTrace(HashMap<String, Trace> traceList) {
		if(getFunctionalCategory().startsWith("*T") ){
			super.traceID = getFunctionalCategory();
			traceList = makeTrace(traceList, traceID);			
		}
		return traceList;
	}
	
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append(super.getID());
		if (insertedForBinarization()) {
			sb.append("X");
		}
		sb.append(": ");
		sb.append(super.getFullCategory());
		if (super.isFiller()) {
			sb.append("-");
			sb.append(super.traceID);
		}
		if (super.isHead()) {
			sb.append("  HEAD");
		}
		if (morphology != null) {
			sb.append("  ");
			sb.append(morphology);
		}
		return sb.toString();
	}

}
