package pltag.german;

import java.util.ArrayList;

public class LTAGDerivation {
	
	private ArrayList<DerivationRel> rel = new ArrayList<DerivationRel>();
	private ArrayList<ElementaryTree> lex;
	private ElementaryTree start = null;

	public LTAGDerivation(ArrayList<ElementaryTree> l) {
		lex = l;
	}

	public void addRelation(DerivationRel r) {
		rel.add(r);
	}
	
	public ArrayList<DerivationRel> getRelations() {
		return rel;
	}
	
	public void setStart(ElementaryTree tree) {
		start = tree;
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(start.toString()).append("\n");
		for (DerivationRel r : rel) {
			sb.append(r.toString());
			sb.append("\n");
		}
		return sb.toString();
	}
	
	public String toStringForOutput() {
		StringBuffer sb = new StringBuffer();
		int st = lex.indexOf(start)+1;
		sb.append(st).append("\t\t\n");
		for (DerivationRel r : rel) {
			int s = lex.indexOf(r.getSourceTree())+1;
			int t = lex.indexOf(r.getTargetTree())+1;
			sb.append(s).append("\t").append(t).append("\t");
			sb.append(r.getAddressInTargetTree()).append("\n");
		}
		return sb.toString();
	}
}
